package com.huimv.guowei.admin.controller;



import com.huimv.guowei.admin.entity.BaseBuilding;
import com.huimv.guowei.admin.service.IBaseBuildingService;
import com.huimv.guowei.admin.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-13
 */
@RestController
@RequestMapping("/baseBuilding")
@CrossOrigin
public class BaseBuildingController {
    @Autowired
    private IBaseBuildingService baseBuildingService;

    @PostMapping("/addBuilding")
    public Result addBuilding(@RequestBody BaseBuilding baseBuilding) {
        return baseBuildingService.addBuilding(baseBuilding);
    }

    @PostMapping("/addSubBuilding")
    public Result addSubBuilding(@RequestBody Map<String, String> map) {
        return baseBuildingService.addSubBuilding(map);
    }

//    @PostMapping( "/addUnit")
//    public Result addUnit(@RequestBody BasePigpen basePigpen) {
//        BasePigpen byId = basePigpenService.getById(basePigpen.getParentId());
//        String parentIds = byId.getOther2() + "," + basePigpen.getParentId();
//        basePigpen.setFType(3);
//        basePigpen.setOther2(parentIds);
//        if ( basePigpenService.save(basePigpen)){
//            return ResultUtil.addResult(1);
//        }
//        return ResultUtil.addResult(0);
//    }

    @PostMapping("/updateBuilding")
    public Result updateBuilding(@RequestBody BaseBuilding baseBuilding) {
         return  baseBuildingService.updateBuilding(baseBuilding);
    }
//
//    @PostMapping( "/updateUnit")
//    public Result updateUnit(@RequestBody BasePigpen basePigpen) {
//        if ( basePigpenService.updateById(basePigpen)){
//            return ResultUtil.addResult(1);
//        }
//        return ResultUtil.addResult(0);
//    }

    @PostMapping("/deleteBuilding")
    public Result deleteBuilding(@RequestBody Map<String,Integer> map) {
        return  baseBuildingService.deleteBuilding(map);
    }

    @PostMapping("/listBuilding")
    public Result listBuilding(@RequestBody Map<String, String> map){
        return baseBuildingService.listBuilding(map);
    }

    @PostMapping("/listTreeBuilding")
    public Result listTreeBuilding(@RequestBody Map<String, String> map){
        return baseBuildingService.listTreeBuilding(map);
    }

//    @PostMapping("/list")
//    public Result list(@RequestBody Map<String, Object> paramsMap) {
//        System.out.println("paramsMap>>"+paramsMap.toString());
//        String farmCode = "";
//        if (paramsMap.get("farmId") != null) {
//            farmCode = paramsMap.get("farmId")+"";
//        }
//        String stageCode = "";
//        if (paramsMap.get("stageCode") != null) {
//            stageCode = paramsMap.get("stageCode")+"";
//        }
//        String buildName = "";
//        if (paramsMap.get("buildName") != null) {
//            buildName = paramsMap.get("buildName")+"";
//        }
//        return baseBuildingService.list(farmCode,buildName,stageCode);
//    }
    @PostMapping("/getUnitEnvironment")
    public Result getUnitEnvironment(@RequestBody Map<String, String> map){
        return baseBuildingService.getUnitEnvironment(map);
    }
    @PostMapping("/getScreenEnvironment")
    public Result getScreenEnvironment(@RequestBody Map<String, String> map){
        return baseBuildingService.getScreenEnvironment(map);
    }

    @PostMapping("/listScreenEnergy")
    public Result listScreenEnergy(){
        return baseBuildingService.listScreenEnergy();
    }

    @PostMapping("/listScreenFeed")
    public Result listScreenFeed(@RequestBody Map<String, String> map){
        return baseBuildingService.listScreenFeed(map);
    }

    @PostMapping("/listScreenDuck")
    public Result listScreenDuck(@RequestBody Map<String, String> map){
        return baseBuildingService.listScreenDuck(map);
    }
}
