package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.PdfUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.common.utils.UploadImage;
import com.huimv.guowei.admin.entity.BaseDuckBreedImg;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.service.IBaseDuckBreedImgService;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/base-duck-info")
@CrossOrigin
public class BaseDuckInfoController {

    @Autowired
    private IBaseDuckInfoService duckInfoService;


    @RequestMapping("/listDuck")
    public Result listDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuck(httpServletRequest, paramsMap);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        duckInfoService.removeById(paramsMap.get("id"));
        return new Result(10000, "删除成功！", true);
    }

    @PostMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestParam(name = "imgUrl",required = false) MultipartFile imgUrl,
                          @RequestParam(name = "farmId") String farmId,
                          @RequestParam(name = "unitList") String unitList,
                          @RequestParam(name = "duckCode") String duckCode,
                          @RequestParam(name = "unitName") String unitName,
                          @RequestParam(name = "duckBreed") String duckBreed,
                          @RequestParam(name = "duckSex") String duckSex,
                          @RequestParam(name = "duckBirthPlace") String duckBirthPlace,
                          @RequestParam(name = "duckBirthDay") String duckBirthDay,
                          @RequestParam(name = "genotype") String genotype,
                          @RequestParam(name = "nowWeight") String nowWeight,
                          @RequestParam(name = "unitId") String unitId,
                          @RequestParam(name = "breedEnv") String breedEnv,
                          @RequestParam(name = "hatchRate", required = false) String hatchRate,
                          @RequestParam(name = "fatherNum") String fatherNum,
                          @RequestParam(name = "motherNum") String motherNum,
                          @RequestParam(name = "fatherGenotype") String fatherGenotype,
                          @RequestParam(name = "motherGenotype") String motherGenotype,
                          @RequestParam(name = "specialNeeds") String specialNeeds) throws Exception {
        httpServletRequest.setCharacterEncoding("UTF-8");
        Map<String, String> map = new HashMap<>();
        map.put("unitList", unitList);
        map.put("unitName", unitName);
        map.put("farmId", farmId);
        map.put("duckCode", duckCode);
        map.put("duckBreed", duckBreed);
        map.put("duckSex", duckSex);
        map.put("duckBirthPlace", duckBirthPlace);
        map.put("duckBirthDay", duckBirthDay);
        map.put("genotype", genotype);
        map.put("nowWeight", nowWeight);
        map.put("unitId", unitId);
        map.put("breedEnv", breedEnv);
        map.put("hatchRate", hatchRate);
        map.put("fatherNum", fatherNum);
        map.put("motherNum", motherNum);
        map.put("fatherGenotype", fatherGenotype);
        map.put("motherGenotype", motherGenotype);
        map.put("specialNeeds", specialNeeds);

        return duckInfoService.addDuck(httpServletRequest, map, imgUrl);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody BaseDuckInfo baseDuckInfo) {
        return duckInfoService.editDuck(httpServletRequest, baseDuckInfo);
    }

    @RequestMapping("/listDuckById")
    public Result listDuckById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuckById(httpServletRequest, paramsMap);
    }

    @PostMapping("/getLocationById")
    public Result getLocationById(@RequestBody Map<String, String> paramsMap){
        String duckNum = paramsMap.get("duckNum");
        BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("duck_num", duckNum));
        if (ObjectUtil.isEmpty(baseDuckInfo)){
            return new Result(10001,"鸭只不存在",false);
        }
        Map resultMap = new HashMap();
        resultMap.put("unitName",baseDuckInfo.getUnitName());
        resultMap.put("unitId",baseDuckInfo.getUnitId());
        return new Result(ResultCode.SUCCESS,resultMap);
    }

    @GetMapping("/printDuck")
    public void printDuck(HttpServletResponse response, @RequestParam(name = "duckCode") String duckCode) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("duckCode", duckCode);
        duckInfoService.printDuck(response, map);
        String path = "/opt/guowei/duck.xls";
        PdfUtil.returnPdfStream3(response, path, "鸭只档案列表");
    }

    //大屏
    @RequestMapping("/listDuckByScreen")
    public Result listDuckByScreen(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuckByScreen(httpServletRequest, paramsMap);
    }
    @RequestMapping("/listDuckByScreen2")
    public Result listDuckByScreen2(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuckByScreen2(httpServletRequest, paramsMap);
    }
}
