package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.Departure;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import com.huimv.guowei.admin.service.IDepartureService;
import com.huimv.guowei.admin.service.IDuckHealthInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/departure")
@CrossOrigin
public class DepartureController {
    @Autowired
    private IDepartureService departureService;
    @Autowired
    private IBaseDuckInfoService infoService;

    @RequestMapping("/list")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return departureService.list(httpServletRequest, paramsMap);
    }
    @RequestMapping("/listByDuckId")
    public Result listByDuckId(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return new Result(ResultCode.SUCCESS,departureService.getById(id));
    }
    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return departureService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestBody Departure departure) {
        departureService.save(departure);
        String duckNum = departure.getDuckNum();
        QueryWrapper<BaseDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", departure.getFarmId()).eq("duck_num", duckNum);
        BaseDuckInfo infoServiceOne = infoService.getOne(queryWrapper);
        infoServiceOne.setIsCage(0);
        infoService.updateById(infoServiceOne);
        return new Result(10000, "添加成功！", true);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody Departure departure) {
        departureService.updateById(departure);
        return new Result(10000, "修改成功！", true);
    }
    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        departureService.removeById(id);
        return new Result(10000, "删除成功！", true);
    }
}
