package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckBodySizeInfo;
import com.huimv.guowei.admin.service.IDuckBodySizeInfoService;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/duck-body-size-info")
@CrossOrigin
public class DuckBodySizeInfoController {
    @Autowired
    private IDuckBodySizeInfoService duckBodySizeInfoService;

    @PostMapping("/addInfo")
    public Result addInfo(@RequestBody DuckBodySizeInfo duckBodySizeInfo){
        duckBodySizeInfoService.save(duckBodySizeInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/deleteInfo")
    public Result deleteInfo(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        duckBodySizeInfoService.removeById(id);
        return Result.SUCCESS();
    }

    @PostMapping("/updateInfo")
    public Result updateInfo(@RequestBody DuckBodySizeInfo duckBodySizeInfo){
        duckBodySizeInfoService.updateById(duckBodySizeInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/getById")
    public Result getById(@RequestBody Map<String, String> paramsMap){
        DuckBodySizeInfo duckBodySizeInfo = duckBodySizeInfoService.getById(paramsMap.get("id"));
        if (ObjectUtil.isEmpty(duckBodySizeInfo)){
            duckBodySizeInfo = new DuckBodySizeInfo();
            duckBodySizeInfo.setBodyLength("");
            duckBodySizeInfo.setChestDeep("");
            duckBodySizeInfo.setChestWide("");
            duckBodySizeInfo.setHalfWaterLength("");
            duckBodySizeInfo.setKeelLength("");
            duckBodySizeInfo.setPelvicWide("");
            duckBodySizeInfo.setShinPerimeter("");
            duckBodySizeInfo.setShinWide("");
        }
        return new Result(ResultCode.SUCCESS,duckBodySizeInfo);
    }

    @PostMapping("/getLastInfo")
    public Result getLastInfo(@RequestBody Map<String, String> paramsMap) {
        return duckBodySizeInfoService.getLastInfo(paramsMap);
    }

    @PostMapping("/listInfo")
    public Result listInfo(@RequestBody Map<String, String> paramsMap){
        return duckBodySizeInfoService.listLimitInfo(paramsMap);
    }

    @PostMapping("/listPageInfo")
    public Result listPageInfo(@RequestBody Map<String, String> paramsMap){
        return duckBodySizeInfoService.listPageInfo(paramsMap);
    }


}
