package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckEggTextureInfo;
import com.huimv.guowei.admin.service.IDuckEggTextureInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/duck-egg-texture-info")
@CrossOrigin
public class DuckEggTextureInfoController {
    @Autowired
    private IDuckEggTextureInfoService duckEggTextureInfoService;

    @PostMapping("/addInfo")
    public Result addInfo(@RequestBody DuckEggTextureInfo duckEggTextureInfo){
        duckEggTextureInfoService.save(duckEggTextureInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/deleteInfo")
    public Result deleteInfo(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        duckEggTextureInfoService.removeById(id);
        return Result.SUCCESS();
    }

    @PostMapping("/updateInfo")
    public Result updateInfo(@RequestBody DuckEggTextureInfo duckEggTextureInfo){
        duckEggTextureInfoService.updateById(duckEggTextureInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/listInfo")
    public Result listInfo(@RequestBody Map<String, String> paramsMap){
        return duckEggTextureInfoService.listLimitInfo(paramsMap);
    }

    @PostMapping("/getById")
    public Result getById(@RequestBody Map<String, String> paramsMap){
        return new Result(ResultCode.SUCCESS,duckEggTextureInfoService.getById(paramsMap.get("id")));
    }

    @PostMapping("/listPageInfo")
    public Result listPageInfo(@RequestBody Map<String, String> paramsMap){
        return duckEggTextureInfoService.listPageInfo(paramsMap);
    }

}
