package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckEggTextureInfo;
import com.huimv.guowei.admin.entity.DuckIncubateInfo;
import com.huimv.guowei.admin.service.IDuckIncubateInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 孵化登记 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/duck-incubate-info")
@CrossOrigin
public class DuckIncubateInfoController {
    @Autowired
    private IDuckIncubateInfoService duckIncubateInfoService;

    @PostMapping("/addInfo")
    public Result addInfo(@RequestBody DuckIncubateInfo duckIncubateInfo){
        duckIncubateInfoService.save(duckIncubateInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/deleteInfo")
    public Result deleteInfo(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        duckIncubateInfoService.removeById(id);
        return Result.SUCCESS();
    }

    @PostMapping("/updateInfo")
    public Result updateInfo(@RequestBody DuckIncubateInfo duckIncubateInfo){
        duckIncubateInfoService.updateById(duckIncubateInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/getById")
    public Result getById(@RequestBody Map<String, String> paramsMap){
        return new Result(ResultCode.SUCCESS,duckIncubateInfoService.getById(paramsMap.get("id")));
    }

    @PostMapping("/listInfo")
    public Result listInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listLimitInfo(paramsMap);
    }

    @PostMapping("/listPageInfo")
    public Result listPageInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listPageInfo(paramsMap);
    }

    @PostMapping("/listWeekInfo")
    public Result listWeekInfo(@RequestBody Map<String, String> paramsMap){
        return duckIncubateInfoService.listWeekInfo(paramsMap);
    }

}
