package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWarningThreshold;
import com.huimv.guowei.admin.entity.EnvDeviceChip;
import com.huimv.guowei.admin.service.IEnergyWarningThresholdService;
import com.huimv.guowei.admin.service.IEnvDeviceChipService;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/energy-warning-threshold")
@CrossOrigin
public class EnergyWarningThresholdController {
    @Resource
    private IEnergyWarningThresholdService energyWarningThresholdService;
    @Resource
    private IEnvDeviceChipService envDeviceChipService;

    @PostMapping("/saveThreshold")
    @Transactional
    public Result saveThreshold(@RequestBody Map<String ,String> paramsMap){
        String maxWater = paramsMap.get("maxWater");
        String maxEle = paramsMap.get("maxEle");
        String maxWaterLine1 = paramsMap.get("maxWaterLine1");
        String maxWaterLine2 = paramsMap.get("maxWaterLine2");
        String maxWaterLine3 = paramsMap.get("maxWaterLine3");
        String maxWaterLine4 = paramsMap.get("maxWaterLine4");
        String maxWaterLinePressure1 = paramsMap.get("maxWaterLinePressure1");
        String maxWaterLinePressure2 = paramsMap.get("maxWaterLinePressure2");
        String maxWaterLinePressure3 = paramsMap.get("maxWaterLinePressure3");
        String maxWaterLinePressure4 = paramsMap.get("maxWaterLinePressure4");
        String farmId = paramsMap.get("farmId");

        maxWater = nullParameter(maxWater);
        maxEle = nullParameter(maxEle);
        maxWaterLine1 = nullParameter(maxWaterLine1);
        maxWaterLine2 = nullParameter(maxWaterLine2);
        maxWaterLine3 = nullParameter(maxWaterLine3);
        maxWaterLine4 = nullParameter(maxWaterLine4);
        maxWaterLinePressure1 = nullParameter(maxWaterLinePressure1);
        maxWaterLinePressure2 = nullParameter(maxWaterLinePressure2);
        maxWaterLinePressure3 = nullParameter(maxWaterLinePressure3);
        maxWaterLinePressure4 = nullParameter(maxWaterLinePressure4);

        EnergyWarningThreshold energyWarningThreshold0 = new EnergyWarningThreshold();
        energyWarningThreshold0.setMaxValue(maxWater);
        energyWarningThreshold0.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold0.setWarningType(0);
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold0,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",0));

        EnergyWarningThreshold energyWarningThreshold1 = new EnergyWarningThreshold();
        energyWarningThreshold1.setMaxValue(maxEle);
        energyWarningThreshold1.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold1.setWarningType(1);
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold1,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",1));

        List<EnvDeviceChip> energyWarningThresholdList = envDeviceChipService.list(new QueryWrapper<EnvDeviceChip>().eq("chip_type",3));
        for (int i = 0; i < energyWarningThresholdList.size(); i++) {
            EnergyWarningThreshold energyWarningThreshold = new EnergyWarningThreshold();
            String maxWaterLine = "";
            if (i == 0) {
                maxWaterLine = maxWaterLine1;
            } else if (i == 1) {
                maxWaterLine = maxWaterLine2;
            } else if (i == 2) {
                maxWaterLine = maxWaterLine3;
            } else if (i == 3) {
                maxWaterLine = maxWaterLine4;
            }
            energyWarningThreshold.setMaxValue(maxWaterLine);
            energyWarningThreshold.setFarmId(Integer.parseInt(farmId));
            energyWarningThreshold.setWarningType(2);
            energyWarningThreshold.setChipCode(energyWarningThresholdList.get(i).getChipCode());
            energyWarningThresholdService.saveOrUpdate(energyWarningThreshold,new UpdateWrapper<EnergyWarningThreshold>()
                    .eq("farm_id",farmId)
                    .eq("warning_type",2).eq("chip_code",energyWarningThresholdList.get(i).getChipCode()));
        }

        List<EnvDeviceChip> energyWarningPressureThresholdList = envDeviceChipService.list(new QueryWrapper<EnvDeviceChip>().eq("chip_type",3));
        for (int i = 0; i < energyWarningPressureThresholdList.size(); i++) {
            EnergyWarningThreshold energyWarningThreshold = new EnergyWarningThreshold();
            String maxWaterLinePressure = "";
            if (i == 0) {
                maxWaterLinePressure = maxWaterLinePressure1;
            } else if (i == 1) {
                maxWaterLinePressure = maxWaterLinePressure2;
            } else if (i == 2) {
                maxWaterLinePressure = maxWaterLinePressure3;
            } else if (i == 3) {
                maxWaterLinePressure = maxWaterLinePressure4;
            }
            energyWarningThreshold.setMaxValue(maxWaterLinePressure);
            energyWarningThreshold.setFarmId(Integer.parseInt(farmId));
            energyWarningThreshold.setWarningType(3);
            energyWarningThreshold.setChipCode(energyWarningThresholdList.get(i).getChipCode());
            energyWarningThresholdService.saveOrUpdate(energyWarningThreshold,new UpdateWrapper<EnergyWarningThreshold>()
                    .eq("farm_id",farmId)
                    .eq("warning_type",3).eq("chip_code",energyWarningThresholdList.get(i).getChipCode()));
        }
        return Result.SUCCESS();
    }

    @PostMapping("/getThreshold")
    public Result getThreshold(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        Map resultMap = new HashMap();
        EnergyWarningThreshold waterThreshold = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 0));
        if (ObjectUtil.isEmpty(waterThreshold)){
            resultMap.put("maxWater",0);
        }else {
            if(!StringUtils.isEmpty(waterThreshold.getMaxValue())){
                resultMap.put("maxWater", waterThreshold.getMaxValue());
            }else {
                resultMap.put("maxWater",0);
            }
        }
        EnergyWarningThreshold eleThreshold = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 1));
        if (ObjectUtil.isEmpty(eleThreshold)){
            resultMap.put("maxEle",0);
        }else {
            if(!StringUtils.isEmpty(eleThreshold.getMaxValue())){
                resultMap.put("maxEle",eleThreshold.getMaxValue());
            }else {
                resultMap.put("maxEle",0);
            }
        }
        //水表
        List<EnergyWarningThreshold> energyWarningThresholdList = energyWarningThresholdService.list(new QueryWrapper<EnergyWarningThreshold>().eq("warning_type", 2).eq("farm_id", farmId));
        if (ObjectUtil.isEmpty(energyWarningThresholdList)){
           resultMap.put("maxWaterLine1",0);
           resultMap.put("maxWaterLine2",0);
           resultMap.put("maxWaterLine3",0);
           resultMap.put("maxWaterLine4",0);
        }
        for (int i = 1; i <= energyWarningThresholdList.size(); i++) {
            EnergyWarningThreshold energyWarningThreshold = energyWarningThresholdList.get(i-1);
            if (ObjectUtil.isEmpty(energyWarningThreshold)){
                resultMap.put("maxWaterLine"+i,0);
            }else {
                if(!StringUtils.isEmpty(energyWarningThreshold.getMaxValue())){
                    resultMap.put("maxWaterLine"+i,energyWarningThreshold.getMaxValue());
                }else {
                    resultMap.put("maxWaterLine"+i,0);
                }
            }
        }
        //水压
        List<EnergyWarningThreshold> energyWarningPressureThresholdList = energyWarningThresholdService.list(new QueryWrapper<EnergyWarningThreshold>().eq("warning_type", 3).eq("farm_id", farmId));
        if (ObjectUtil.isEmpty(energyWarningPressureThresholdList)){
            resultMap.put("maxWaterLinePressure1",0);
            resultMap.put("maxWaterLinePressure2",0);
            resultMap.put("maxWaterLinePressure3",0);
            resultMap.put("maxWaterLinePressure4",0);
        }
        for (int i = 1; i <= energyWarningPressureThresholdList.size(); i++) {
            EnergyWarningThreshold energyWarningThreshold = energyWarningPressureThresholdList.get(i-1);
            if (ObjectUtil.isEmpty(energyWarningThreshold)){
                resultMap.put("maxWaterLinePressure"+i,0);
            }else {
                if(!StringUtils.isEmpty(energyWarningThreshold.getMaxValue())){
                    resultMap.put("maxWaterLinePressure"+i,energyWarningThreshold.getMaxValue());
                }else {
                    resultMap.put("maxWaterLinePressure"+i,0);
                }
            }
        }
        return new Result(ResultCode.SUCCESS,resultMap);
    }

    public String nullParameter(String param){
        if (StringUtils.isEmpty(param)){
            param = "0";
        }
        return param;
    }


}
