package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.PdfUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvRegularCallEgg;
import com.huimv.guowei.admin.service.IEnvRegularCallEggService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 固定电子秤 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-regular-call-egg")
@CrossOrigin
public class EnvRegularCallEggController {

    @Autowired
    private IEnvRegularCallEggService eggService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addEgg")
    public Result addEgg(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return eggService.addEgg(httpServletRequest, paramsMap);
    }
    @RequestMapping("/editEgg")
    public Result editEgg(HttpServletRequest httpServletRequest, @RequestBody EnvRegularCallEgg egg) throws ParseException {
        return eggService.updateEgg(httpServletRequest, egg);
    }
    @RequestMapping("/deleteEgg")
    public Result deleteEgg(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return eggService.deleteEgg(httpServletRequest, paramsMap);
    }

    @GetMapping("/printEgg")
    public void printDuck(HttpServletResponse response, @RequestParam(name = "duckCode") String duckCode) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("duckCode", duckCode);
        eggService.printEgg(response, map);
        String path = "/opt/guowei/egg.xls";
        PdfUtil.returnPdfStream3(response, path, "鸭只采食产蛋列表");
    }

    @RequestMapping("/listByH5")
    public Result listByH5(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.listByH5(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSeven")
    public Result listSeven(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.listSeven(httpServletRequest, paramsMap);
    }


    //大屏
    //采集器
    @RequestMapping("/collector")
    public Result collector(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.collector(httpServletRequest, paramsMap);
    }

    //控制器
    @RequestMapping("/collectorEnv")
    public Result collectorEnv(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return eggService.collectorEnv(httpServletRequest, paramsMap);
    }
}
