package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.SysCamera;
import com.huimv.guowei.admin.entity.vo.CameraListVo;
import com.huimv.guowei.admin.entity.vo.CameraListsVo;
import com.huimv.guowei.admin.service.ISysCameraService;
import javafx.scene.Camera;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/admin/cameraBase")
@CrossOrigin
public class SysCameraController {
    @Autowired
    private ISysCameraService cameraService;

    @PostMapping("/list")
    public Result list(@RequestBody CameraListVo cameraListVo) {
        return cameraService.listPage(cameraListVo);
    }

    @PostMapping("/add")
    public Result add(@RequestBody SysCamera camera) {

        if (camera == null) {
            return new Result(ResultCode.FAIL, "添加失败");
        }


        return cameraService.add(camera);

    }

    @PostMapping("/update")
    public Result update(@RequestBody SysCamera camera) {
        return cameraService.updates(camera);

    }

    @GetMapping("/remove")
    public Result remove(@RequestParam(value = "ids") List<Integer> ids) {
        cameraService.removeByIds(ids);
        return new Result(ResultCode.SUCCESS, "删除成功");
    }

    @PostMapping("/getCameraDetails")
    private Result getCameraDetails(@RequestBody CameraListsVo cameraListsVo) throws InterruptedException {

        List list = cameraService.getCameraDetails(cameraListsVo);
        return new Result(ResultCode.SUCCESS, list);
    }
}
