package com.huimv.guowei.admin.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.guowei.admin.entity.EnergyElectricity;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
public interface EnergyElectricityMapper extends BaseMapper<EnergyElectricity> {

    List<EnergyElectricity> listDayDetail(String farmId);

    List<EnergyElectricity> listWeekDetail(String farmId);

    List<EnergyElectricity> listMonthDetail(String farmId);

    List<EnergyElectricity> listCustomDetail(@Param("farmId") String farmId, @Param("startDate") String startDate, @Param("endDate") String endDate);

    BigDecimal getDayElectricity(String farmId);

    BigDecimal getMonthElectricity(String farmId);

    BigDecimal getElectricity(@Param(Constants.WRAPPER) QueryWrapper<EnergyElectricity> queryWrapper);

    List<EnergyElectricity> listSixMonthElectricity(String farmId,String unitId);

    List<EnergyElectricity> listSevenDayElectricity(String farmId,String unitId);

    BigDecimal getLastFlowByUnitId(String farmId, String unitId);

    BigDecimal getDayUnitElectricity(String farmId, String unitId);

    List<EnergyElectricity> listUnitDayElectricity(String farmId, String unitId);

    List<EnergyElectricity> listUnitMonthElectricity(String farmId, String unitId);
}
