package com.huimv.guowei.admin.mqtt.moveScale;

import lombok.Data;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.List;

@Configuration
@Data
public class ReceiveData extends Thread {
    public static final String HOST = "tcp://115.238.57.190:1883";
    //    public static final String TOPIC1 = "/today/#";//请阅地址
    private String clientid="GuoWeiReceive";
    private static MqttClient client;
    private static MqttConnectOptions options;

    private static String userName = "admin";    //非必须
    private static String passWord = "admin";  //非必须
    private List<String> topics;

    @Override
    public void run() {
        try {
            // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
            client = new MqttClient(HOST, clientid, new MemoryPersistence());
            // MQTT的连接设置
            options = new MqttConnectOptions();
            // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
            options.setCleanSession(true);
            // 设置连接的用户名
            options.setUserName(userName);
            // 设置连接的密码
            options.setPassword(passWord.toCharArray());
            // 设置超时时间 单位为秒
            options.setConnectionTimeout(10);
            // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
            options.setKeepAliveInterval(20);
            //设置断开后重新连接
            options.setAutomaticReconnect(false);
            // 设置回调
            client.setCallback(new DataBack());

            client.connect(options);

            for (String topic : topics) {
                if (topic.equals("865328066116350")) {
                    //订阅消息
                    client.subscribe("huimv_GW_down",0);
                }
                if (topic.equals("865328063440043")) {
                    //订阅消息
                    client.subscribe("huimv_GW_down",0);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
