package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.DuckBodySizeInfo;
import com.huimv.guowei.admin.entity.vo.DuckBodySizeInfoVo;
import com.huimv.guowei.admin.mapper.BaseDuckInfoMapper;
import com.huimv.guowei.admin.mapper.DuckBodySizeInfoMapper;
import com.huimv.guowei.admin.service.IDuckBodySizeInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@Service
public class DuckBodySizeInfoServiceImpl extends ServiceImpl<DuckBodySizeInfoMapper, DuckBodySizeInfo> implements IDuckBodySizeInfoService {
    @Resource
    private DuckBodySizeInfoMapper duckBodySizeInfoMapper;
    @Resource
    private BaseDuckInfoMapper baseDuckInfoMapper;

    @Override
    public Result listLimitInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String num = paramsMap.get("num");
        List<DuckBodySizeInfoVo> duckBodySizeInfoList = duckBodySizeInfoMapper.listLimitInfo(num,farmId);
        return new Result(ResultCode.SUCCESS,duckBodySizeInfoList);
    }

    @Override
    public Result listPageInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String unitName = paramsMap.get("unitName");
        Page<DuckBodySizeInfoVo> page = new Page(Integer.parseInt(pageNo),Integer.parseInt(pageSize));
        Page<DuckBodySizeInfoVo> duckBodySizeInfoPage = duckBodySizeInfoMapper.listPageInfo(page,unitName,farmId);
        return new Result(ResultCode.SUCCESS,duckBodySizeInfoPage);
    }

    @Override
    public Result getLastInfo(Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        DuckBodySizeInfo duckBodySizeInfo = duckBodySizeInfoMapper.getLastInfo(baseDuckInfoMapper.selectById(id).getDuckNum());
        if (ObjectUtil.isEmpty(duckBodySizeInfo)){
            duckBodySizeInfo = new DuckBodySizeInfo();
            duckBodySizeInfo.setBodyLength("");
            duckBodySizeInfo.setChestDeep("");
            duckBodySizeInfo.setChestWide("");
            duckBodySizeInfo.setHalfWaterLength("");
            duckBodySizeInfo.setKeelLength("");
            duckBodySizeInfo.setPelvicWide("");
            duckBodySizeInfo.setShinPerimeter("");
            duckBodySizeInfo.setShinWide("");
        }
        return new Result(ResultCode.SUCCESS,duckBodySizeInfo);
    }
}
