package com.huimv.guowei.admin.service.impl;

import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckBodySizeInfo;
import com.huimv.guowei.admin.entity.DuckEggTextureInfo;
import com.huimv.guowei.admin.mapper.DuckEggTextureInfoMapper;
import com.huimv.guowei.admin.service.IDuckEggTextureInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@Service
public class DuckEggTextureInfoServiceImpl extends ServiceImpl<DuckEggTextureInfoMapper, DuckEggTextureInfo> implements IDuckEggTextureInfoService {
    @Resource
    private DuckEggTextureInfoMapper duckEggTextureInfoMapper;

    @Override
    public Result listLimitInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String num = paramsMap.get("num");
        List<DuckEggTextureInfo> duckEggTextureInfoList = duckEggTextureInfoMapper.selectList(new QueryWrapper<DuckEggTextureInfo>()
                .eq("farm_id",farmId).orderByDesc("determine_time").last("limit "+num));
        return new Result(ResultCode.SUCCESS,duckEggTextureInfoList);
    }

    @Override
    public Result listPageInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String unitName = paramsMap.get("unitName");
        Page<DuckEggTextureInfo> page = new Page(Integer.parseInt(pageNo),Integer.parseInt(pageSize));
        Page<DuckEggTextureInfo> duckEggTextureInfoPage = duckEggTextureInfoMapper.selectPage(page,
                new QueryWrapper<DuckEggTextureInfo>().like("unit_name",unitName).eq("farm_id",farmId));
        return new Result(ResultCode.SUCCESS,duckEggTextureInfoPage);
    }
}
