package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWaterPressure;
import com.huimv.guowei.admin.entity.EnvDeviceChip;
import com.huimv.guowei.admin.entity.vo.WaterLinePressureVo;
import com.huimv.guowei.admin.entity.vo.WaterLineVo;
import com.huimv.guowei.admin.mapper.EnergyWaterMapper;
import com.huimv.guowei.admin.mapper.EnergyWaterPressureMapper;
import com.huimv.guowei.admin.mapper.EnvDeviceChipMapper;
import com.huimv.guowei.admin.service.IEnergyWaterPressureService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-21
 */
@Service
public class EnergyWaterPressureServiceImpl extends ServiceImpl<EnergyWaterPressureMapper, EnergyWaterPressure> implements IEnergyWaterPressureService {

    @Resource
    private EnergyWaterPressureMapper energyWaterPressureMapper;
    @Resource
    private EnvDeviceChipMapper envDeviceChipMapper;

    @Override
    public Result getWaterPressure(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String unitId = paramsMap.get("unitId");
        List<EnvDeviceChip> deviceChipList = envDeviceChipMapper.selectList(new QueryWrapper<EnvDeviceChip>().eq("unit_id",unitId).eq("chip_type", 5));
        List<String> chipCodeList = new ArrayList<>();
        for (EnvDeviceChip envDeviceChip : deviceChipList) {
            chipCodeList.add(envDeviceChip.getChipCode());
        }
        String chipCodes = String.join(",", chipCodeList);
        WaterLinePressureVo waterLinePressureVo = new WaterLinePressureVo();
        waterLinePressureVo.setValue1("0");
        waterLinePressureVo.setValue2("0");
        waterLinePressureVo.setValue3("0");
        waterLinePressureVo.setValue4("0");
        chipCodes = "("+chipCodes+")";
        if (ObjectUtil.isNotEmpty(deviceChipList)){
            waterLinePressureVo = energyWaterPressureMapper.getWaterPressure(farmId,chipCodeList,chipCodes);
        }
        return new Result(ResultCode.SUCCESS,waterLinePressureVo);
    }

    @Override
    public Result listWaterPressure(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String unitId = paramsMap.get("unitId");
        String type = paramsMap.get("type");
        List<EnvDeviceChip> deviceChipList = envDeviceChipMapper.selectList(new QueryWrapper<EnvDeviceChip>().eq("unit_id",unitId).eq("chip_type", 5));
        List<String> chipCodeList = new ArrayList<>();
        for (EnvDeviceChip envDeviceChip : deviceChipList) {
            chipCodeList.add(envDeviceChip.getChipCode());
        }
        String chipCodes = String.join(",", chipCodeList);
        List<WaterLinePressureVo> waterLinePressureVo = new ArrayList<>();
        chipCodes = "("+chipCodes+")";
        if (ObjectUtil.isEmpty(deviceChipList)){
            return new Result(ResultCode.SUCCESS,waterLinePressureVo);
        }
        if ("1".equals(type)){
            waterLinePressureVo = energyWaterPressureMapper.listDayWaterPressure(farmId,chipCodeList,chipCodes);
        }else {
            waterLinePressureVo = energyWaterPressureMapper.listMonthWaterPressure(farmId,chipCodeList,chipCodes);
        }

        return new Result(ResultCode.SUCCESS,waterLinePressureVo);
    }
}
