package com.huimv.guowei.admin.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.guowei.admin.entity.*;
import com.huimv.guowei.admin.entity.vo.EnvRegularCallEggVo;
import org.jxls.common.Context;
import org.jxls.util.JxlsHelper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Print {
    /**
     * 打印方法  不插入图片
     *
     * @return
     * @throws Exception
     */
    public static void printDuck(BaseDuckInfo duckInfo, List<DuckHealthInfo> healthInfos,
                                 List<DuckImmunityInfo> immunityInfos, List<EnvMoveCall> envMoveCalls) throws Exception {
        //准备数据
        String path = "/opt/guowei/duck.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/duck.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        context.putVar("duckCode", duckInfo.getDuckNum());
        context.putVar("duckType", duckInfo.getDuckBreed());
        context.putVar("duckSex", duckInfo.getDuckSex());
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        context.putVar("duckDate",sdf.format( duckInfo.getDuckBirthday()));
        context.putVar("address", duckInfo.getDuckBirthplace());
        context.putVar("father", duckInfo.getFatherNum());
        context.putVar("father2", duckInfo.getFatherGenotype());
        context.putVar("mother", duckInfo.getMotherNum());
        context.putVar("mother2", duckInfo.getMotherGenotype());
        String s = "";
        String s1 = "";
        String s2 = "";
        //健康状况
        for (DuckHealthInfo healthInfo : healthInfos) {
            s1 = sdf.format(healthInfo.getHealthDate()) + healthInfo.getHealthResult() + ";" + "\n" + s1;
        }
        //日龄体重
        for (EnvMoveCall envMoveCall : envMoveCalls) {
            s = envMoveCall.getDayage() + "日龄 体重" + ":" + envMoveCall.getDuckWeight() + "KG;" + "\n" + s;
        }
        //免疫记录
        for (DuckImmunityInfo immunityInfo : immunityInfos) {
            s2 = sdf.format(immunityInfo.getHealthDate()) + immunityInfo.getVaccination() + ";" + "\n" + s2;
        }
        context.putVar("weight", s);
        context.putVar("need", duckInfo.getSpecialNeeds());
        context.putVar("env", duckInfo.getBreedingEnv());
        context.putVar("record", s1);
        context.putVar("record2", s2);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

    public static void printEgg(List<EnvRegularCallEgg> eggs, List<EnvRegularCallFeeding> feedings) throws Exception {

        //准备数据
        String path = "/opt/guowei/egg.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/egg.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<EnvRegularCallEggVo> list = new ArrayList<>();
        int i = 0;
        for (EnvRegularCallFeeding feeding : feedings) {
            EnvRegularCallEggVo eggVo = new EnvRegularCallEggVo();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            eggVo.setDate(sdf.format(feeding.getCallDate()));
            eggVo.setDuckCode(feeding.getDuckNum());
            eggVo.setFeed(feeding.getDuckWeight());
            Integer eggNum = eggs.get(i).getEggNum();
            eggVo.setEggNum(eggNum);
            eggVo.setWeight(eggs.get(i).getDuckWeight());
            i = i+1;
            list.add(eggVo);
        }
        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

}